<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <CommonHeader 
      title="All Schedules"
      description="Your own scheduled benchmarks are listed here."
    >
      <v-btn small :disabled="!enabledActions.create" @click="$emit('newSchedule', {name:'New Schedule', scheduling_hints: {interval: {}}, id:null, active:false, grants:{owner:'me'}})">New Schedule</v-btn>
    </CommonHeader>

    <Filterbox
      :filteredSize="filteredItems.length"
      :itemsName="['schedule', 'schedules']"
      v-on:changed="filterkey=$event.key"
    />

    <v-list three-line>
      <v-list-item-group color="primary">
        <ScheduleSummary
          @selected="$emit('viewSchedule', item)"
          :key="item.data"
          v-for="(item) in filteredItems"
          :item="item"
        />
      </v-list-item-group>
    </v-list>
      
  </v-container>

</template>


<script>

import CommonHeader from '../common/CommonHeader.vue';
import Filterbox from '../common/Filterbox.vue';
import ScheduleSummary from './ScheduleSummary.vue';

import { getScheduleSharingLevel, getBenchmarkResultsSharingLevel } from '../common/benchsuite.js';

export default {

  name: 'WorkloadsList',

 components: {
    CommonHeader,
    ScheduleSummary,
    Filterbox
  },
  
  data: () => ({
    schedules: [],
    filterkey: "",
    enabledActions: {
      create:false
    }
  }),

  mounted () {
    this.$store.commit('fbkon')
    this.$http
      .get(this.$REST_BASE_URL + '/schedules')
      .then(response => (this.schedules = response.data))
      .finally(() => {
        this.$store.commit('fbkoff')
        this.$vuetify.goTo(0, {duration:200})
      });
    // update actions
    this.$http
          .get(this.$REST_BASE_URL + "/schedules/user_actions")
      .then(response => {
        this.enabledActions.create = response.data.create=="True";
      })
    this.$emit("title", "Schedules");
  },

  computed: {
    filteredItems() {
      return this.schedules.filter(item => {
        if(!this.filterkey)
          return true;
        var text = "";
        for(var k in item) {
          text += " " + item[k];
        }
        if(item.provider) {
          for(k in item.provider) {
            text += " " + item.provider[k];
          }
        }
        if(item.service_types) {
          for(var i in item.service_types) {
            var st = item.service_types[i];
            for(k in st) {
              text += " " + st[k];
            }
          }
        }
        if(item.workloads) {
          for(i in item.workloads) {
            var wl = item.workloads[i];
            for(k in wl) {
              text += " " + wl[k];
            }
          }
        }
        if(item.active) text+=" active "; else text+=" paused ";
        text += " " + getScheduleSharingLevel(item);
        text += " " + getBenchmarkResultsSharingLevel(item);
        return text.toLowerCase().includes(this.filterkey.toLowerCase());
      }).sort((a,b) => {return (b.name.toLowerCase()+b.id) < (a.name.toLowerCase()+a.id) ? 1 : -1});
    }
  }

};

</script>

<style>
div.provider-name {
  font-weight:bold;
}
</style>


